Index: uspace/app/virtusbkbd/Makefile
===================================================================
--- uspace/app/virtusbkbd/Makefile	(revision 243cb862efdca342a3d56442ae4a4fe91c8c1e81)
+++ uspace/app/virtusbkbd/Makefile	(revision ebb98c507c792200fded755acdf34b4ff05af60a)
@@ -33,5 +33,5 @@
 
 LIBS = $(LIBUSB_PREFIX)/libusb.a $(LIBUSBVIRT_PREFIX)/libusbvirt.a
-EXTRA_CFLAGS = -I$(LIBUSB_PREFIX)/include -I$(LIB_PREFIX) -I$(LIBDRV_PREFIX)/include
+EXTRA_CFLAGS = -I$(LIBUSB_PREFIX)/include -I$(LIB_PREFIX)
 
 SOURCES = \
Index: uspace/drv/usbkbd/main.c
===================================================================
--- uspace/drv/usbkbd/main.c	(revision 243cb862efdca342a3d56442ae4a4fe91c8c1e81)
+++ uspace/drv/usbkbd/main.c	(revision ebb98c507c792200fded755acdf34b4ff05af60a)
@@ -28,210 +28,75 @@
 #include <usb/usbdrv.h>
 #include <driver.h>
-#include <ipc/driver.h>
 #include <errno.h>
-#include <fibril.h>
-#include <usb/classes/hid.h>
-#include <usb/classes/hidparser.h>
-#include <usb/devreq.h>
 
 #define BUFFER_SIZE 32
-#define NAME "usbkbd"
 
-static const usb_endpoint_t CONTROL_EP = 0;
-
-/*
- * Callbacks for parser
- */
-static void usbkbd_process_keycodes(const uint16_t *key_codes, size_t count,
-                                    void *arg)
-{
-
-}
-
-/*
- * Kbd functions
- */
-static int usbkbd_get_descriptors()
-{
-	// copy-pasted:
-	
-	/* Prepare the setup packet. */
-	usb_device_request_setup_packet_t setup_packet = {
-		.request_type = 128,
-		.request = USB_DEVREQ_GET_DESCRIPTOR,
-		.index = 0,
-		.length = sizeof(usb_standard_device_descriptor_t)
-	};
-	
-	setup_packet.value_high = USB_DESCTYPE_DEVICE;
-	setup_packet.value_low = 0;
-
-	/* Prepare local descriptor. */
-	size_t actually_transferred = 0;
-	usb_standard_device_descriptor_t descriptor_tmp;
-
-	/* Perform the control read transaction. */
-	int rc = usb_drv_psync_control_read(phone, target,
-	    &setup_packet, sizeof(setup_packet),
-	    &descriptor_tmp, sizeof(descriptor_tmp), &actually_transferred);
-
-	if (rc != EOK) {
-		return rc;
-	}
-	
-	// end of copy-paste
-}
-
-static usb_hid_dev_kbd_t *usbkbd_init_device(device_t *dev)
-{
-	usb_hid_dev_kbd_t *kbd_dev = (usb_hid_dev_kbd_t *)malloc(
-			sizeof(usb_hid_dev_kbd_t));
-
-	if (kbd_dev == NULL) {
-		fprintf(stderr, NAME ": No memory!\n");
-		return NULL;
-	}
-
-	kbd_dev->device = dev;
-
-	// get phone to my HC and save it as my parent's phone
-	// TODO: maybe not a good idea if DDF will use parent_phone
-	kbd_dev->device->parent_phone = usb_drv_hc_connect(dev, 0);
-
-	kbd_dev->address = usb_drv_get_my_address(dev->parent_phone,
-	    dev);
-
-	// doesn't matter now that we have no address
-//	if (kbd_dev->address < 0) {
-//		fprintf(stderr, NAME ": No device address!\n");
-//		free(kbd_dev);
-//		return NULL;
-//	}
-
-	// default endpoint
-	kbd_dev->default_ep = CONTROL_EP;
-
-	// TODO: get descriptors
-	usbkbd_get_descriptors();
-	// TODO: parse descriptors and save endpoints
-
-	return kbd_dev;
-}
-
-static void usbkbd_process_interrupt_in(usb_hid_dev_kbd_t *kbd_dev,
-                                        uint8_t *buffer, size_t actual_size)
-{
-	/*
-	 * here, the parser will be called, probably with some callbacks
-	 * now only take last 6 bytes and process, i.e. send to kbd
-	 */
-
-	usb_hid_report_in_callbacks_t *callbacks =
-	    (usb_hid_report_in_callbacks_t *)malloc(
-		sizeof(usb_hid_report_in_callbacks_t));
-	callbacks->keyboard = usbkbd_process_keycodes;
-
-	usb_hid_parse_report(kbd_dev->parser, buffer, callbacks, NULL);
-}
-
-static void usbkbd_poll_keyboard(usb_hid_dev_kbd_t *kbd_dev)
+/* Call this periodically to check keyboard status changes. */
+static void poll_keyboard(device_t *dev)
 {
 	int rc;
 	usb_handle_t handle;
-	uint8_t buffer[BUFFER_SIZE];
+	char buffer[BUFFER_SIZE];
 	size_t actual_size;
-	//usb_endpoint_t poll_endpoint = 1;
+	usb_endpoint_t poll_endpoint = 1;
 
-//	usb_address_t my_address = usb_drv_get_my_address(dev->parent_phone,
-//	    dev);
-//	if (my_address < 0) {
-//		return;
-//	}
+	usb_address_t my_address = usb_drv_get_my_address(dev->parent_phone,
+	    dev);
+	if (my_address < 0) {
+		return;
+	}
 
 	usb_target_t poll_target = {
-		.address = kbd_dev->address,
-		.endpoint = kbd_dev->default_ep
+		.address = my_address,
+		.endpoint = poll_endpoint
 	};
 
-	while (true) {
-		rc = usb_drv_async_interrupt_in(kbd_dev->device->parent_phone,
-		    poll_target, buffer, BUFFER_SIZE, &actual_size, &handle);
-
-		if (rc != EOK) {
-			continue;
-		}
-
-		rc = usb_drv_async_wait_for(handle);
-		if (rc != EOK) {
-			continue;
-		}
-
-		/*
-		 * If the keyboard answered with NAK, it returned no data.
-		 * This implies that no change happened since last query.
-		 */
-		if (actual_size == 0) {
-			continue;
-		}
-
-		/*
-		 * TODO: Process pressed keys.
-		 */
-		usbkbd_process_interrupt_in(kbd_dev, buffer, actual_size);
+	rc = usb_drv_async_interrupt_in(dev->parent_phone, poll_target,
+	    buffer, BUFFER_SIZE, &actual_size, &handle);
+	if (rc != EOK) {
+		return;
 	}
 
-	// not reached
-	assert(0);
+	rc = usb_drv_async_wait_for(handle);
+	if (rc != EOK) {
+		return;
+	}
+
+	/*
+	 * If the keyboard answered with NAK, it returned no data.
+	 * This implies that no change happened since last query.
+	 */
+	if (actual_size == 0) {
+		return;
+	}
+
+	/*
+	 * Process pressed keys.
+	 */
 }
 
-static int usbkbd_fibril_device(void *arg)
-{
-	printf("!!! USB device fibril\n");
-
-	if (arg == NULL) {
-		printf("No device!\n");
-		return -1;
-	}
-
-	device_t *dev = (device_t *)arg;
-
-	// initialize device (get and process descriptors, get address, etc.)
-	usb_hid_dev_kbd_t *kbd_dev = usbkbd_init_device(dev);
-
-	usbkbd_poll_keyboard(kbd_dev);
-
-	return EOK;
-}
-
-static int usbkbd_add_device(device_t *dev)
+static int add_kbd_device(device_t *dev)
 {
 	/* For now, fail immediately. */
-	//return ENOTSUP;
+	return ENOTSUP;
 
 	/*
 	 * When everything is okay, connect to "our" HC.
-	 *
-	 * Not supported yet, skip..
 	 */
-//	int phone = usb_drv_hc_connect(dev, 0);
-//	if (phone < 0) {
-//		/*
-//		 * Connecting to HC failed, roll-back and announce
-//		 * failure.
-//		 */
-//		return phone;
-//	}
+	int phone = usb_drv_hc_connect(dev, 0);
+	if (phone < 0) {
+		/*
+		 * Connecting to HC failed, roll-back and announce
+		 * failure.
+		 */
+		return phone;
+	}
 
-//	dev->parent_phone = phone;
+	dev->parent_phone = phone;
 
 	/*
-	 * Create new fibril for handling this keyboard
+	 * Just for fun ;-).
 	 */
-	fid_t fid = fibril_create(usbkbd_fibril_device, dev);
-	if (fid == 0) {
-		printf("%s: failed to start fibril for HID device\n", NAME);
-		return ENOMEM;
-	}
-	fibril_add_ready(fid);
+	poll_keyboard(dev);
 
 	/*
@@ -242,9 +107,9 @@
 
 static driver_ops_t kbd_driver_ops = {
-	.add_device = usbkbd_add_device,
+	.add_device = add_kbd_device,
 };
 
 static driver_t kbd_driver = {
-	.name = NAME,
+	.name = "usbkbd",
 	.driver_ops = &kbd_driver_ops
 };
Index: uspace/lib/usb/include/usb/classes/hid.h
===================================================================
--- uspace/lib/usb/include/usb/classes/hid.h	(revision 243cb862efdca342a3d56442ae4a4fe91c8c1e81)
+++ uspace/lib/usb/include/usb/classes/hid.h	(revision ebb98c507c792200fded755acdf34b4ff05af60a)
@@ -36,8 +36,4 @@
 #define LIBUSB_HID_H_
 
-#include <usb/usb.h>
-#include <driver.h>
-#include <usb/classes/hidparser.h>
-
 /** USB/HID device requests. */
 typedef enum {
@@ -58,16 +54,4 @@
 } usb_hid_protocol_t;
 
-/**
- * @brief USB/HID keyboard device type.
- *
- * Quite dummy right now.
- */
-typedef struct {
-	device_t *device;
-	usb_address_t address;
-	usb_endpoint_t default_ep;
-	usb_hid_report_parser_t *parser;
-} usb_hid_dev_kbd_t;
-
 #endif
 /**
Index: uspace/lib/usb/include/usb/classes/hidparser.h
===================================================================
--- uspace/lib/usb/include/usb/classes/hidparser.h	(revision 243cb862efdca342a3d56442ae4a4fe91c8c1e81)
+++ uspace/lib/usb/include/usb/classes/hidparser.h	(revision ebb98c507c792200fded755acdf34b4ff05af60a)
@@ -50,5 +50,5 @@
 	 * @param arg Custom argument.
 	 */
-	void (*keyboard)(const uint16_t *key_codes, size_t count, void *arg);
+	void (*keyboard)(const uint32_t *key_codes, size_t count, void *arg);
 } usb_hid_report_in_callbacks_t;
 
Index: uspace/lib/usb/src/hidparser.c
===================================================================
--- uspace/lib/usb/src/hidparser.c	(revision 243cb862efdca342a3d56442ae4a4fe91c8c1e81)
+++ uspace/lib/usb/src/hidparser.c	(revision ebb98c507c792200fded755acdf34b4ff05af60a)
@@ -62,15 +62,5 @@
     const usb_hid_report_in_callbacks_t *callbacks, void *arg)
 {
-	int i;
-	
-	// TODO: parse report
-	
-	uint16_t keys[6];
-	
-	for (i = 0; i < 6; ++i) {
-		keys[i] = data[i];
-	}
-	
-	callbacks->keyboard(keys, 6, arg);
+	return ENOTSUP;
 }
 
